Index: /trunk/src/VBox/Main/idl/VirtualBox.xidl
===================================================================
--- /trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 45565)
+++ /trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 45566)
@@ -9578,14 +9578,14 @@
     </const>
     <const name="Broken"                value="1">
-      <desc>TODO</desc>
+      <desc>Input pipe is broken.</desc>
     </const>
     <const name="Available"             value="10">
-      <desc>TODO</desc>
+      <desc>Input pipe became available for writing.</desc>
     </const>
     <const name="Written"               value="50">
-      <desc>TODO</desc>
+      <desc>Data has been successfully written.</desc>
     </const>
     <const name="Overflow"              value="100">
-      <desc>TODO</desc>
+      <desc>Too much input data supplied, data overflow.</desc>
     </const>
   </enum>
@@ -9603,17 +9603,17 @@
     </const>
     <const name="Opening"               value="10">
-      <desc>TODO</desc>
+      <desc>Guest file is opening.</desc>
     </const>
     <const name="Open"                  value="100">
-      <desc>TODO</desc>
+      <desc>Guest file has been successfully opened.</desc>
     </const>
     <const name="Closing"               value="150">
-      <desc>TODO</desc>
+      <desc>Guest file closing.</desc>
     </const>
     <const name="Closed"                value="200">
-      <desc>TODO</desc>
+      <desc>Guest file has been closed.</desc>
     </const>
     <const name="Down"                  value="600">
-      <desc>TODO</desc>
+      <desc>Service/OS is stopping, guest file was closed.</desc>
     </const>
     <const name="Error"                 value="800">
@@ -9705,13 +9705,15 @@
     >
     <desc>
-      TODO
+      The IGuestErrorInfo interface represents extended error information which
+      happened while performing an operation on the guest.
     </desc>
 
     <attribute name="result" type="long" readonly="yes">
-      <desc>TODO</desc>
+      <desc>Runtime (IPRT) error code. See include/iprt/err.h and include/VBox/err.h
+        for details.</desc>
     </attribute>
 
     <attribute name="text" type="wstring" readonly="yes">
-      <desc>TODO</desc>
+      <desc>Text description of the error.</desc>
     </attribute>
 
@@ -10865,5 +10867,5 @@
     <attribute name="status" type="FileStatus" readonly="yes">
       <desc>
-        TODO
+        Current file status.
       </desc>
     </attribute>
@@ -18999,55 +19001,61 @@
     <const name="OnGuestSessionStateChanged" value="80">
       <desc>
-        TODO
+        See <link to="IGuestSessionStateChangedEvent">IGuestSessionStateChangedEvent</link>.
       </desc>
     </const>
     <const name="OnGuestSessionRegistered" value="81">
       <desc>
-        TODO
+        See <link to="IGuestSessionRegisteredEvent">IGuestSessionRegisteredEvent</link>.
       </desc>
     </const>
     <const name="OnGuestProcessRegistered" value="82">
       <desc>
-        TODO
+        See <link to="IGuestProcessRegisteredEvent">IGuestProcessRegisteredEvent</link>.
       </desc>
     </const>
     <const name="OnGuestProcessStateChanged" value="83">
       <desc>
-        TODO
+        See <link to="IGuestProcessStateChangedEvent">IGuestProcessStateChangedEvent</link>.
       </desc>
     </const>
     <const name="OnGuestProcessInputNotify" value="84">
       <desc>
-        TODO
+        See <link to="IGuestProcessInputNotifyEvent">IGuestProcessInputNotifyEvent</link>.
       </desc>
     </const>
     <const name="OnGuestProcessOutput" value="85">
       <desc>
-        TODO
+        See <link to="IGuestProcessOutputEvent">IGuestProcessOutputEvent</link>.
       </desc>
     </const>
     <const name="OnGuestFileRegistered" value="86">
       <desc>
-        TODO
+        See <link to="IGuestFileRegisteredEvent">IGuestFileRegisteredEvent</link>.
       </desc>
     </const>
     <const name="OnGuestFileStateChanged" value="87">
       <desc>
-        TODO
+        See <link to="IGuestFileStateChangedEvent">IGuestFileStateChangedEvent</link>.
       </desc>
     </const>
     <const name="OnGuestFileOffsetChanged" value="88">
       <desc>
-        TODO
+        See <link to="IGuestFileOffsetChangedEvent">IGuestFileOffsetChangedEvent</link>.
       </desc>
     </const>
     <const name="OnGuestFileRead" value="89">
       <desc>
-        For performance reasons ... TODO
+        See <link to="IGuestFileReadEvent">IGuestFileReadEvent</link>.
+        
+        <note internal="yes">For performance reasons this is a separate event to
+          not unnecessarily overflow the event queue.</note>          
       </desc>
     </const>
     <const name="OnGuestFileWrite" value="90">
       <desc>
-        For performance reasons ... TODO
+        See <link to="IGuestFileWriteEvent">IGuestFileWriteEvent</link>.
+      
+        <note internal="yes">For performance reasons this is a separate event to
+          not unnecessarily overflow the event queue.</note>          
       </desc>
     </const>
@@ -19944,20 +19952,21 @@
     >
     <desc>
-      TODO
+      Notification when a guest session changed its state.
     </desc>
 
     <attribute name="id" type="unsigned long" readonly="yes">
       <desc>
-        TODO
+        Session ID of guest session which was changed.
       </desc>
     </attribute>
     <attribute name="status" type="GuestSessionStatus" readonly="yes">
       <desc>
-        TODO
+        New session status.
       </desc>
     </attribute>
     <attribute name="error" type="IGuestErrorInfo" readonly="yes">
       <desc>
-        TODO
+        Extended guest error information in case of new session
+        status is indicating an error.
       </desc>
     </attribute>
@@ -19971,10 +19980,11 @@
     >
     <desc>
-      TODO
+      Notification when a guest session was registered or unregistered.
     </desc>
 
     <attribute name="registered" type="boolean" readonly="yes">
       <desc>
-        TODO
+        If @c true, the guest session was registered, otherwise it was
+        unregistered.
       </desc>
     </attribute>
@@ -19991,10 +20001,10 @@
     <attribute name="process" type="IGuestProcess" readonly="yes">
       <desc>
-        TODO
+        Guest process object which is related to this event.
       </desc>
     </attribute>
     <attribute name="pid" type="unsigned long" readonly="yes">
       <desc>
-        TODO
+        Guest process ID (PID).
       </desc>
     </attribute>
@@ -20008,10 +20018,11 @@
     >
     <desc>
-      TODO
+      Notification when a guest process was registered or unregistered.
     </desc>
 
     <attribute name="registered" type="boolean" readonly="yes">
       <desc>
-        TODO
+        If @c true, the guest process was registered, otherwise it was
+        unregistered.
       </desc>
     </attribute>
@@ -20025,15 +20036,16 @@
     >
     <desc>
-      TODO
+      Notification when a guest process changed its state.
     </desc>
 
     <attribute name="status" type="ProcessStatus" readonly="yes">
       <desc>
-        TODO
+        New guest process status.
       </desc>
     </attribute>
     <attribute name="error" type="IGuestErrorInfo" readonly="yes">
       <desc>
-        TODO
+        Extended guest error information in case of new process
+        status is indicating an error.
       </desc>
     </attribute>
@@ -20052,5 +20064,6 @@
     <attribute name="handle" type="unsigned long" readonly="yes">
       <desc>
-        TODO
+        Input/output (IO) handle involved in this event. Usually 0 is stdin,
+        1 is stdout and 2 is stderr.
       </desc>
     </attribute>
@@ -20058,5 +20071,5 @@
     <attribute name="processed" type="unsigned long" readonly="yes">
       <desc>
-        TODO
+        Processed input or output (in bytes).
       </desc>
     </attribute>
@@ -20070,10 +20083,11 @@
     >
     <desc>
-      TODO
+      Notification when a guest process' stdin became available.
+      <note>This event is right now not implemented!</note>
     </desc>
 
     <attribute name="status" type="ProcessInputStatus" readonly="yes">
       <desc>
-        TODO
+        Current process input status.
       </desc>
     </attribute>
@@ -20087,10 +20101,10 @@
     >
     <desc>
-      TODO
+      Notification when there is guest process output available for reading.
     </desc>
 
     <attribute name="data" type="octet" safearray="yes" readonly="yes">
       <desc>
-        TODO
+        Actual output data.
       </desc>
     </attribute>
@@ -20107,5 +20121,5 @@
     <attribute name="file" type="IGuestFile" readonly="yes">
       <desc>
-        TODO
+        Guest file object which is related to this event.
       </desc>
     </attribute>
@@ -20119,10 +20133,11 @@
     >
     <desc>
-      TODO
+      Notification when a guest file was registered or unregistered.
     </desc>
 
     <attribute name="registered" type="boolean" readonly="yes">
       <desc>
-        TODO
+        If @c true, the guest file was registered, otherwise it was
+        unregistered.
       </desc>
     </attribute>
@@ -20136,15 +20151,16 @@
     >
     <desc>
-      TODO
+      Notification when a guest file changed its state.
     </desc>
 
     <attribute name="status" type="FileStatus" readonly="yes">
       <desc>
-        TODO
+        New guest file status.
       </desc>
     </attribute>
     <attribute name="error" type="IGuestErrorInfo" readonly="yes">
       <desc>
-        TODO
+        Extended guest error information in case of new file
+        status is indicating an error.
       </desc>
     </attribute>
@@ -20166,12 +20182,11 @@
     <attribute name="offset" type="long long" readonly="yes">
       <desc>
-        TODO
+        Current offset (in bytes).
       </desc>
     </attribute>
     <attribute name="processed" type="unsigned long" readonly="yes">
       <desc>
-        TODO
-      </desc>
-
+        Processed input or output (in bytes).
+      </desc>
     </attribute>
 
@@ -20184,5 +20199,5 @@
     >
     <desc>
-      TODO
+      Notification when a guest file changed its current offset.
     </desc>
 
@@ -20195,10 +20210,10 @@
     >
     <desc>
-      TODO
+      Notification when data has been read from a guest file.
     </desc>
 
     <attribute name="data" type="octet" safearray="yes" readonly="yes">
       <desc>
-        TODO
+        Actual data read.
       </desc>
     </attribute>
@@ -20212,5 +20227,5 @@
     >
     <desc>
-      TODO
+      Notification when data has been written to a guest file.
     </desc>
 